package xyz.ottr.spec.wottr;

import static org.junit.Assert.assertTrue;

import java.io.*;
import java.util.Arrays;
import java.util.Collection;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.Resource;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

@RunWith(Parameterized.class)
public class CorrectSHACL {
	
	private String dataURL;

	public CorrectSHACL(String dataURL) {
		this.dataURL = dataURL;
	}
	
	@Parameters(name = "{index}: {0}")
	public static Collection<String> collectInput () {
		String[] dataFiles = { Util.GRAMMAR, Util.TYPES, Util.STD_TOKENS, Util.TOKENS };
		return Arrays.asList(dataFiles);
	}

	@Test
	public void test() throws FileNotFoundException {
		Model shapeModel = Util.getModel("http://www.w3.org/ns/shacl-shacl", Util.STD_TOKENS);
		Model dataModel = Util.getModel(dataURL);
		Resource report = Util.getReport(shapeModel, dataModel);
		boolean conforms = Util.isConforms(report);
		if (!conforms) {
			Util.printModel(report.getModel());
		}
		assertTrue(conforms);
	}
}